'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _cssColorNames = require('css-color-names');

var _cssColorNames2 = _interopRequireDefault(_cssColorNames);

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _postcssValueParser = require('postcss-value-parser');

var _postcssValueParser2 = _interopRequireDefault(_postcssValueParser);

var plugin = 'postcss-color-yiq';

function err(node) {
    throw node.parent.error('No background color was found.', { plugin: plugin });
}

function getYIQContrast(colour) {
    var _color$rgbArray = (0, _color2['default'])(colour).rgbArray();

    var _color$rgbArray2 = _slicedToArray(_color$rgbArray, 3);

    var r = _color$rgbArray2[0];
    var g = _color$rgbArray2[1];
    var b = _color$rgbArray2[2];

    var yiq = (r * 299 + g * 587 + b * 114) / 1000;
    return yiq >= 128 ? '#000' : '#fff';
}

exports['default'] = _postcss2['default'].plugin(plugin, function () {
    return function (css) {
        css.walkDecls('color', function (decl) {
            if (decl.value !== 'yiq') {
                return;
            }

            var background = decl.parent.nodes.filter(function (_ref) {
                var prop = _ref.prop;

                return prop === 'background' || prop === 'background-color';
            }).pop();

            if (typeof background === 'undefined') {
                err(decl);
            }

            var hasColour = false;

            decl.value = (0, _postcssValueParser2['default'])(background.value).walk(function (node) {
                if (node.type === 'function' && /^(rgb|hsl)a?$/.test(node.value)) {
                    node.value = getYIQContrast((0, _postcssValueParser.stringify)(node));
                    node.type = 'word';
                    hasColour = true;
                    return;
                }
                if (node.type === 'word') {
                    if (!node.value.indexOf('#')) {
                        node.value = getYIQContrast(node.value);
                        hasColour = true;
                        return;
                    } else if (node.value in _cssColorNames2['default']) {
                        node.value = getYIQContrast(_cssColorNames2['default'][node.value]);
                        hasColour = true;
                        return;
                    }
                }
                node.value = '';
                node.nodes = null;
            }).toString();

            if (!hasColour) {
                decl.value = 'yiq';
                err(decl);
            }
        });
    };
});
module.exports = exports['default'];